package naito.module.complex.mroadselector;

import rescuecore2.misc.geometry.*;
import rescuecore2.worldmodel.EntityID;
import rescuecore2.standard.entities.Area;
import adf.agent.info.AgentInfo;
import adf.agent.info.WorldInfo;
import rescuecore2.standard.entities.*;

import java.util.*;
import java.util.stream.*;

public class Util
{
    public static Point2D toPoint2D(AgentInfo ai)
    {
        return new Point2D(ai.getX(), ai.getY());
    }

    public static Point2D toPoint2D(Area area)
    {
        return new Point2D(area.getX(), area.getY());
    }

    public static <T> T getLast(List<T> list)
    {
        if (list == null)
            return null;

        if (list.size() == 0)
            return null;

        return list.get(list.size()-1);
    }

    public static List<Blockade> toBlockades(Area area, WorldInfo wi)
    {
        if (area.isBlockadesDefined() == false)
            return new ArrayList<Blockade>();

        List<EntityID> blockadeIDs = area.getBlockades();
        if (blockadeIDs == null)
            return new ArrayList<Blockade>();

        return blockadeIDs.stream()
            .map(eid -> (Blockade)wi.getEntity(eid))
            .collect(Collectors.toList());
    }

    public static List<java.awt.Shape> toShapes(List<Blockade> blockades)
    {
        return blockades.stream()
            .map(Blockade::getShape)
            .collect( Collectors.toList() );
    }
}
