package naito.tactics.mpolice;

import adf.agent.info.WorldInfo;
import adf.agent.info.AgentInfo;
import adf.agent.action.Action;
import adf.agent.action.common.ActionRest;
import adf.agent.action.common.ActionMove;
import adf.agent.action.police.ActionClear;
import rescuecore2.standard.entities.*;
import rescuecore2.misc.geometry.*;
import rescuecore2.worldmodel.EntityID;
import java.util.*;

public class Util
{
    public static Point2D toPoint2D(AgentInfo ai)
    {
        return new Point2D(ai.getX(), ai.getY());
    }

    public static Point2D toPoint2D(Area area)
    {
        return new Point2D(area.getX(), area.getY());
    }

    public static <T> T getLast(List<T> list)
    {
        if (list == null)
            return null;

        if (list.size() == 0)
            return null;

        return list.get(list.size()-1);
    }

    public static Point2D toPoint2D(Action action, WorldInfo wi, AgentInfo ai)
    {
        if (action instanceof ActionClear)
        {
            ActionClear actionClear = (ActionClear)action;
            return new Point2D(actionClear.getPosX(), actionClear.getPosY());
        }

        if (action instanceof ActionMove)
        {
            ActionMove actionMove = (ActionMove)action;
            if (actionMove.getUsePosition())
                return new Point2D(actionMove.getPosX(), actionMove.getPosY());

            EntityID areaID = getLast(actionMove.getPath());
            Area area = (Area)wi.getEntity(areaID);
            return toPoint2D(area);
        }

        if (action instanceof ActionRest || action == null)
        {
            EntityID areaID = ai.getPosition();
            Area area = (Area)wi.getEntity(areaID);
            return toPoint2D(area);
        }

        return null;
    }
}
