package naito.util.passable;

import rescuecore2.worldmodel.EntityID;
import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Blockade;
import rescuecore2.misc.geometry.*;
import adf.agent.info.WorldInfo;

import java.util.*;
import java.util.stream.*;
import java.awt.Shape;

public class AreaUtil
{
    public static List<Blockade> toBlockades(Area area, WorldInfo wi)
    {
        if (area.isBlockadesDefined() == false)
            return new ArrayList<Blockade>();

        List<EntityID> blockadeIDs = area.getBlockades();
        if (blockadeIDs == null)
            return new ArrayList<Blockade>();

        return blockadeIDs.stream()
            .map(eid -> (Blockade)wi.getEntity(eid))
            .collect(Collectors.toList());
    }

    public static List<Shape> toShapes(List<Blockade> blockades)
    {
        return blockades.stream()
            .map(Blockade::getShape)
            .collect( Collectors.toList() );
    }

    public static List<Line2D> toLines(List<Blockade> blockades)
    {
        return blockades.stream()
            .map(Blockade::getApexes)
            .map(GeometryTools2D::vertexArrayToPoints)
            .map(GeometryTools2D::pointsToLines)
            .flatMap(List::stream)
            .collect(Collectors.toList());
    }
}
