package naito.util.passable;

import rescuecore2.misc.geometry.GeometryTools2D;
import rescuecore2.misc.geometry.Line2D;
import rescuecore2.misc.geometry.Point2D;
import rescuecore2.misc.geometry.Vector2D;

import java.lang.Math;

public class GeometryMath
{
    public static Point2D center(Line2D line)
    {
        Point2D origin   = line.getOrigin();
        Point2D endpoint = line.getEndPoint();

        return new Point2D(
            origin.getX() + (endpoint.getX()-origin.getX())/2,
            origin.getY() + (endpoint.getY()-origin.getY())/2
        );
    }

    public static double distance(Line2D line, Point2D point)
    {
        double crossProduct = cross(
            line.getDirection(),
            point.minus( line.getOrigin() )
        );

        double area  = Math.abs(crossProduct);

        double side1 = line.getDirection().getLength();

        return area / side1;
    }

    public static double cross(Vector2D v1, Vector2D v2)
    {
        double x1 = v1.getX();
        double y1 = v1.getY();
        double x2 = v2.getX();
        double y2 = v2.getY();

        return x1*y2 - y1*x2;
    }
}
